seg_a           segment byte public
assume  cs:seg_a

                jumps
                org     100h
ProgrammStart:
                DB 'WC Plugin',1Ah
                DW TYPE_sounds
                DW offset FFD_description
;                DB 'WAVCAP Plugin',1Ah
                DW 0

                DW 0
                DW 0
                DW 0
                DW offset GetInfo            ;Get info & Get RAW only !
                DW offset GetRAW
                include wcplg.inc

GetInfo:
                lds dx,FromFile
                call Fopen
                jc IO_Error

                lds si,CurFile
                mov cx,W ds:[si+ToPosition+2];Seek to some position -
                mov dx,W ds:[si+ToPosition]  ;Required if there are captured files
                mov al,SEEK_SET              ;From start of file
                call Fseek
                jc IO_Error

                push cs
                pop ds
                mov dx,offset aHDR
                mov cx,37h
                call Fread
                jc IO_Error
                cmp ax,cx
                jne IO_Error

                cmp W cs:[aHDR],'DD'         ;"DDSF" - header
                jne Unsupportedformat
                cmp W cs:[aHDR+2],'FS'
                jne Unsupportedformat

                les di,SoundInfo
                mov ax,W cs:[aHDR+2Fh]
                mov W es:[di+ToFreq],ax

                mov al,B cs:[aHDR+32h]
                and al,10b                   ;If second byte set - 16 bit...
                cmp al,0
                je a8bitsound

                mov W es:[di+ToBits],16
                mov cs:[a16bit],1
a8bitsound:
                mov dx,W cs:[aHDR+2Bh]
                mov cx,W cs:[aHDR+2Dh]

                cmp cs:[a16bit],0
                je NoRecalcNeed

                shl cx,1
                shl dx,1                     ;*2
                jnc NoNeedForExtraBit
                or cx,1
NoNeedForExtraBit:
NoRecalcNeed:
                mov W es:[di+ToRAWLength],dx
                mov W es:[di+ToRAWLength+2],cx
                xor ax,ax
                retf


aHDR            DB 37h dup (?)
a16bit          DB 0

Unsupportedformat:
                call Fclose                  ;Close file
                mov ax,CantRetriveInfo       ;Error code: CantRetriveInfo
                retf                         ;Bye bye !


;*************************
GetRAW:
                mov cx,cs:[ReadLength]       ;Length , that must be readed
                cmp cx,0                     ;into buffer
                je CloseAndByeBye            ;If zero - must close file

                lds dx,Buffer
                call Fread
                jc IO_Error

                cmp ax,cx                    ;Not all bytes readed ?
                jne IO_Error                 ;Error return !!!!!!!

                cmp cs:[a16bit],1
                je WellDone

                lds si,Buffer
Swapping:
                mov al,B ds:[si]
                xor al,80h
                mov B ds:[si],al
                inc si
                loop Swapping

WellDone:
                xor ax,ax                    ;Return code: All OK !
                retf                         ;Bye Bye !

CloseAndByeBye:
                call Fclose                  ;Close file
                jc IO_Error
                xor ax,ax                    ;Return code: All OK !
                retf                         ;Bye Bye !
FFD_description:
                DB 'Delusion Digital Sound File',0


                seg_a ends
                end     ProgrammStart
